v2.1.3 (19 oct 2025):
* Analog Generator: new option "Always play Osc2" (play additional oscillator even if Osc2=0);
* Modulator: Max PM (Phase Modulation) delay: added values 8, 16, 32 sec;
* Modulator: new controller "PM interpolation";
* MetaModule: new buttons in the user defined controller editor: "]+" (add after); "+[" (add before);
* Sampler: the new "Reverse" controller lets you play a sample backwards; limitation: if a loop is enabled, the playback position immediately jumps inside the loop in reverse mode;
* export to audio: new option "Seamless Loop" (the tail from the end of the project will be mixed into the beginning of the file);
* controller properties: added a "Write all to pattern" button;
* controller properties: now there are separate input fields for decimal and hexadecimal values;
* new buttons in the pattern icon editor: INV (invert colors), New (generate a new icon), Copy, Paste;
* text selection in input fields (currently only for devices with a physical keyboard); available shortcuts: SHIFT+ARROWS; SHIFT+INS/DEL; CTRL+A/X/C/V;
* prefixes in text input fields for conversion from one number system to another: 0xVALUE - from hexadecimal to decimal; 0tVALUE - from decimal to hexadecimal;
* new keyboard shortcut (unassigned by default) for the module editor: Write the values of all controllers of the selected module to the current pattern;
* now, in addition to the standard set of buttons, you can add any keyboard shortcuts to each toolbar; details are in changelog_details.txt and on the website: https://warmplace.ru/soft/sunvox/manual.php#toolbars
* Android: new option: Preferences -> Main -> Broad access to files; allows you to write to and read almost any folder (except system folders) on internal and external memory cards; for example, this is convenient for working with a collection of samples in a shared folder that can be accessed by multiple music apps;
  unfortunately, the version on Google Play doesn't have this option, as Google has not approved the use of the MANAGE_EXTERNAL_STORAGE permission; if you need this feature, install the APK file directly: https://warmplace.ru/temp/SunVox.apk
* bug fixes.
v2.1.2c (22 dec 2024):
* iOS: bug fixes.
v2.1.2b (14 dec 2024):
* bug fixes.
v2.1.2 (15 oct 2024):
* new module Smooth - it attempts to follow the waveform of the incoming signal, smoothing out sharp changes in accordance with the Rise and Fall parameters;
* new modulation types in FMX and Analog Generator (Osc2 modes):
  - min abs: if( abs(in2) < abs(in1) ) out = in2; else out = in1;
  - max abs: if( abs(in2) > abs(in1) ) out = in2; else out = in1;
* Modulator: additional modulation types (as in FMX and Analog Generator) have been added;
* MetaModule: new options: (see simple_examples/metamodule options 78,79.sunvox)
  - 79 - ignore effect 31 (jump to line XXYY) after the last Note OFF; works only if "Play patterns" >= 3;
  - 78 - jump to the "RL" pattern after the last Note OFF; works only if "Play patterns" >= 3;
* LFO: improved quality of waveforms "saw", "triangle" and "random interpolated" (26 bits instead of 15);
* Filter Pro: max value of the Roll-off controller has been raised to 96dB;
* Filter Pro: since version 2.1.2 the Roll-off controller also affects the All-pass filter type; see simple_examples/freq dispersion.sunvox;
* Reverb: improved type of all-pass filter has been added to controller 8 - it has almost no effect on the gain of the original signal frequencies;
* Delay: new controller "Negative feedback" for changing the sign of feedback;
* Delay: new controller "All-pass filter" for switching the module to All-pass mode, where the filter order is the delay length in samples;
* Glide: new controllers "Octave", "Frequency multiply" and "Frequency divide";
* MultiCtl: new button "Set" for precise curve modification;
* MultiCtl: new button "+" (next to the controller number) - press it if you want to change multiple controllers within a single module; see simple_examples/multictl.sunvox;
* Pitch Detector: new algorithm - "spectral peak"; it determines the frequency of the loudest harmonic with high accuracy; suitable for signals with pronounced fundamental harmonic;
* Pitch Detector: additional info under the controllers: incoming signal frequency; frequency range; output note frequency;
* Pitch Detector: the maximum detected frequencies for algorithms 1 and 2 are 2000 Hz and 1000 Hz; but these values will double if the following conditions are met: base version >= 2.1.2; LP filter == 0; Alg1-2 Sample rate >= 44100;
* Sampler: new controller "Record" (stop/pause/start recording); see simple_examples/sampler rec automation.sunvox;
* sample editor: new function "Set the start position" (position at which the sample will start playing);
* sample editor: new function "Adjust to specified length (without resampling)" (editor menu -> Misc) - allows you to set a note at which the sample will fit exactly into the specified length;
* sample editor: new functions "Convert to 8/16/32bit" (editor menu -> Misc);
* sample editor: view settings (in the menu) allow you to set the units (samples, seconds, ticks, etc.) in which the cursor position and selection size will be displayed;
* sample editor: PLAY (from the cursor position) button has been added;
* sample editor: improved sample wave display (with correct peak drawing; versions for arm64 and x86_64+SSSE3 (OpenGL) provides the best quality);
* sample editor: the following parameters have been added to the "Create a new sample" and "Resample" dialogs: interpolation type; length in lines and seconds; "Just crop/extend (no resampling)" option;
* pattern effect 34: new option 8 has been added - enable it if you need to output 7-bit MIDI controller values, even if the controller is 14-bit (0-31);
* new keyboard shortcuts (unassigned by default):
  - previous layout;
  - next layout;
  - layout: normal;
  - layout: timeline;
  - layout: pattern editor;
  - layout: module view + controllers;
  - layout: controllers;
  - layout: module view;
* new keyboard shortcuts (unassigned by default) for the module editor:
  - toggle LINK mode (connecting modules);
* new keyboard shortcuts (unassigned by default) for the timeline:
  - next pattern horizontally;
  - previous pattern horizontally;
  - next pattern vertically;
  - previous pattern vertically;
* new keyboard shortcuts (unassigned by default) for the brush:
  - play current note (in the pattern editor), copy it to the brush and go to the next line;
  - play current line (in the pattern editor), copy it to the brush and go to the next line;
* new options in sunvox_config.ini:
  - no_clog - disable logging to console;
  - no_flog - disable logging to file; also see the corresponding command line options -ncl and -nfl;
  - jack_nodefin - don't set default JACK input connections;
  - jack_nodefout - don't set default JACK output connections;
  - jack_drmin - don't restore JACK MIDI IN connections;
* the file dialog now remembers the cursor position in each folder;
* mouse scroll wheel support on Android;
* Windows: new sound driver DirectSound2 allows buffer size to be reduced to 512 - this may be useful if you can't use ASIO for some reason;
* 64-bit versions (non-OpenGL) can now run on CPUs without SSSE3 support;
* new modules and examples (see changelog_files.txt);
* full SunVox Library sources are now available, so you can rebuild it (for different platform or with different options) if necessary: https://warmplace.ru/soft/sunvox/sunvox_lib.php
* minor improvements, bug fixes, increased stability.
v2.1.1c (29 nov 2023):
* Sampler: new controller "Tick length" (affects the duration of the envelopes);
* new example: NightRadio - Frozen;
* bug fixes.
v2.1.1b (1 nov 2023):
* fixed bug with saving OGG sample.
v2.1.1 (22 oct 2023):
* iOS 11 support has been dropped; now the minimum is 12;
* now you can also load samples in the following formats (on ALL platforms): 64-bit WAV/AIFF, OGG (Vorbis), MP3, FLAC;
* export to FLAC and OGG (Vorbis);
* Modulator: the accuracy of the phase modulation mode has been increased (but only if the version of SunVox 2.1.1 (and higher) is specified in the project properties);
* Modulator: new controller "Max phase modulation delay";
* Vorbis player: new controller "Ignore Note OFF" (play every note endlessly);
* MetaModule: new option "Auto BPM/TPL" (synchronize BPM and TPL of the module with BPM and TPL of the parent project);
* Pattern Editor: new function "Sync with timeline" - sync the cursor with the timeline (+shortcut, unassigned by default);
* Timeline: new function "Sync with pat.editor" - sync the cursor with the pattern editor (+shortcut, unassigned by default);
* sample editor: new function "Mono to stereo" (editor menu -> Misc);
* auto-repeat in the virtual (on-screen) text keyboard;
* new modules and examples (see changelog_files.txt);
* bug fixes.
v2.1c (15 mar 2023):
* bug fixes (including several bugs in the USB MIDI code on Android).
v2.1b (7 feb 2023):
* Loop: new controller "On NoteON" (restart with transition to zero iteration (record);restart current iteration); see simple_examples/loop4.sunvox;
* pattern effect 34: new value 4 - use Round-robin keyboard track allocation algorithm, instead of default tight packing; may be required for live play on the MultiSynth module with the "trigger" option; but this option may cause the brush to work incorrectly;
* bug fixes.
v2.1 (1 feb 2023):
* iOS: now the interface is displayed in high resolution; if you want to switch back to the normal low resolution mode (on some devices this will increase the FPS) - go to the Preferences -> Interface -> Low resolution;
* iOS: Preferences -> Audio -> Additional options: new option "minimize the amount of system-supplied signal processing" (measurement mode);
* iOS 9 support has been dropped; now the minimum is 11;
* macOS 10.9 support has been dropped; now the minimum is 10.13;
* Wi-Fi export/import is now also available on Android;
* high resolution icons;
* high resolution fonts with fractional scaling (only in OpenGL version, including iOS, Android, macOS, Windows and Linux); you can disable these features in Preferences -> Interface -> Fonts;
* sound engine optimization;
* Distortion: new type "saturation" (adding odd harmonics) + five of its variations;
* MultiSynth: new option "Output port number = random" (three different algorithms are available);
* Loop: new controller "Length unit" (line/128;line;line/2;line/3;tick;ms;Hz);
* Loop: new controller "Maximum buffer size" (in seconds) to protect against allocating too much memory;
* Loop: the maximum of the "Repeat" controller has been increased to 128 (128 = repeat endlessly);
* new curve types for ADSR and FMX modules: rect; smooth rect; 2-bit (linear); 3-bit; 4-bit; 5-bit;
* module editor menu: new function "Mute/Solo buttons" to show/hide the Bypass/Mute/Solo buttons under each module;
* musical keyboard: the new panel with additional functions and settings; to open it - increase the height of the keyboard and press the appeared "+" button;
* musical keyboard settings: type (classic, uniform, free (any frequency)), number of rows, key width, color inversion, autorepeat;
* new way to edit a pattern - drawing with a brush; go the pattern editor menu and select "Draw" - this will open the pattern drawing tools;
* for a more detailed description of working with a brush, see changelog_details.txt or https://warmplace.ru/soft/sunvox/manual.php#pdraw
* new features in the pattern editor menu: Copy to brush; Reverse; Draw (open pattern drawing tools);
* Preferences -> Timeline: new option "Hexadecimal track numbers";
* Preferences -> Toolbars: the buttons on the horizontal dividers can be customized here; see changelog_details.txt or https://warmplace.ru/soft/sunvox/manual.php#toolbars
* pattern editor menu -> Remap: module number -1 = all modules;
* more detailed pattern names after the live recording;
* new pattern effect (column EE): 35 - bind MIDI OUT message XX (0 - Program Change; 1 - Channel Pressure; 2 - Pitch Bend Change) to controller YY (0 - OFF; 0x80 - MIDI controller 0; 0x81 - MIDI controller 1...); for the specified module only;
* new special pattern command: "XX" - stop the module, clear its internal buffers and put it into standby mode;
* new keyboard shortcuts (unassigned by default) that open the corresponding tool windows in the pattern editor:
  * interpolate;
  * transpose;
  * cyclic shift;
  * set effect;
  * draw;
* new keyboard shortcuts (unassigned by default) for the pattern editor:
  * clear pattern;
  * shrink pattern /2;
  * expand pattern *2;
  * slice by cursor;
  * reverse;
  * pattern properties;
  * show/hide CCEEXXYY columns;
  * scale;
  * insert a special command "Stop the Module" (XX);
* new keyboard shortcuts for working with the brush:
  * CTRL+E - play current note (in the pattern editor) and copy it to the brush;
  * CTRL+L - play the notes of the current line (in the pattern editor) and copy it to the brush;
  * play the 1st line of the brush (unassigned by default);
  * сopy selected area of the pattern to the brush (unassigned by default);
  * CTRL+G - paste from the brush;
* new modules in the instruments/ and effects/ folders;
* new examples:
  * SunVox Compo 2022.02 winners: fuzion_mixer & Logickin - Synthonic Voyage, RobloxFan75000 - Hypermatic, PhilipBergwerf - We want Peace;
  * NightRadio - Cycles of Light;
* updated version of SunVox library for developers: https://warmplace.ru/soft/sunvox/sunvox_lib.php
* bug fixes.
v2.0e (5 mar 2022):
* bug fixes (Generator, UI).
v2.0d (14 feb 2022):
* bug fixes (UI).
v2.0c (31 jan 2022):
* bug fixes (LFO, Delay, UI).
v2.0b (26 jan 2022):
* bug fixes.
v2.0 (23 jan 2022):
* iOS 11+: SunVox Audio Unit (AUv3) can now send MIDI notes and MIDI CC to other AU modules;
* iOS 13.4+: full USB/Bluetooth keyboard support (like on desktops);
* multiple module selection (see changelog_details.txt) + ability to save several selected modules to a sunvox file;
* timeline: supertracks (see changelog_details.txt and simple_examples/supertracks.sunvox);
* improved import of old tracker formats (XM and MOD);
* new module - FMX: 5-operator Frequency Modulation synth;
* new module - FFT frequency transformator;
* sound engine optimization;
* the name of the current file is now visible in the title bar of the app window;
* module and timeline editor: "Select All" has been changed to "Select/Unselect All";
* timeline menu: new option "Vertical mode"; +shortcut
* timeline menu: new functions "Load" and "Save" to load/save selected patterns from/to a sunvox file;
* timeline menu: new function "Detach" to convert the clones to the normal patterns; +shortcut
* module editor menu: new function "Detach" to detach the selected modules from the rest; +shortcut
* module editor menu: new function "Make MetaModule" for packing the selected modules into a single MetaModule; +shortcut
* now it is possible to delete modules, but keep the links;
* pattern properties: X and Y fields - exact coordinates of the pattern on the timeline;
* module properties: X and Y fields - exact coordinates of the module;
* module visualizer: "Phase Sync" oscilloscope option has been added; activate it to see a single waveform cycle;
* module visualizer: new buttons "reset", "apply", "copy", "paste";
* ADSR->Sustain: new value "Repeat" (repeat the envelope until the module is stopped);
* ADSR->Smooth Transitions: new value "volume change" (the volume will change smoothly, but the envelope start is not smoothed);
* Amplifier: new controller "Bipolar DC Offset";
* Analog Generator: the "Freq2" controller has been ranamed to "Osc2" (pitch deviation of the additional oscillator);
* Analog Generator: new controller "Osc2 volume" - additional oscillator volume;
* Analog Generator: new controller "Osc2 mode" - mixing mode of the additional oscillator with the main one (add;sub;mul;min;max;bitwise AND;bitwise XOR);
* Analog Generator: new controller "Osc2 phase" - starting phase of the additional oscillator;
* Analog Generator: new option "Increased frequency computation accuracy";
* Delay: new controller "Delay multiplier";
* Delay: new "Delay unit" values: sec/44100, sec/48000, sample;
* Delay: max delay length has been increased to 60 sec;
* Delay: new controller "Feedback" (for sound and events);
* Echo: new controller "Right channel offset" (how much to shift the right channel relative to the left in time);
* Echo: new controller "Filter";
* Echo: new controller "Filter frequency";
* Filter Pro: new modes "stereo + smoothing" and "mono + smoothing" for additional parameter smoothing;
* Filter Pro: new types "LP 6dB" and "HP 6dB";
* LFO: new controller "Sine quality";
* MetaModule->Play patterns: new values "on (repeat, endless)" and "on (no repeat, endless)";
* MetaModule: number of user defined controllers has been increased to 96;
* MetaModule: controller color can now be changed by adding "@X" to the beginning of the name, where X is the group number from 0 to F; group colors (c_cgp0, c_cgp1, etc.) can be changed in sunvox_config.ini;
* MultiSynth: new option "Output port number = round-robin (cyclic)";
* Sampler: new option "Increased frequency computation accuracy";
* FM, SpectraVoice, Kicker, DrumSynth: clicks removal algorithm has been implemented - it is useful when the volume changes quickly or there are not enough polyphony channels;
* FM: the "M.Feedback" controller has been renamed to "M.Self-modulation";
* Vocal Filter: new controllers "Random frequency" and "Random seed";
* Vocal Filter: new controllers "Vowel1", "Vowel2", "Vowel3", "Vowel4", "Vowel5";
* effect 1С will work a little differently if you fill in its parameter as 10YY - this means that the velocity will be reset to 0 after YY ticks; (normal parameter 00YY means Note OFF after YY ticks);
* new pattern effects (column EE):
  * 1A - fine velocity slide up/down (XX - up speed; YY - down speed); once at the beginning of a line;
  * 33 - slot sync (for sv_sync_resume() in SunVox library);
  * 34 - set (XX) or reset (YY) project options: 1 - no portamento on the first tick; 2 - no velocity slide on the first tick; (for compatibility with old tracker formats);
  * 3C - copy track XX from from the pattern YY; for example, if XXYY = 0023, then the first track will be copied from the pattern named "23";
  * 3D - write a random value to track YY; min value, max value and column must be in track 0, starting from line XX; see example "pat effect 3D random value";
         (columns: 0 - NN; 1 - VV; 2 - MM; 3 - CC; 4 - EE; 5 - XX; 6 - YY; 7 - XXYY);
* corrected Mute/Solo algorithm for modules;
* OpenGL accelerated versions for Windows and Linux;
* new options in sunvox_config.ini: controller group colors c_cgp0, c_cgp1, etc.;
* new options in sunvox_config.ini: module layer colors c_layer0, c_layer1, c_layer2, etc.;
* new options in sunvox_config.ini: c_pbtn, c_pbtn_op, c_pscroll, c_pateditor_level, c_pateditor_cursor, show_sel_btn, show_sbars, edit_mode;
* new curves in curves/MultiSynth/curve3 for different equal temperament systems (for example, ET19 - 19 tones per octave);
* new modules in the instruments/ and effects/ folders;
* new examples (SunVox Compo 2021.02 winners): Logickin - Mech Haven, So_ingMachine - Some of our tracks cant be covered, kiberaver - electric dreams;
* new examples: NightRadio - Afterglow, NightRadio - Winter Is Coming;
* updated version of SunVox library for developers: https://warmplace.ru/soft/sunvox/sunvox_lib.php
* bug fixes.
v1.9.6c (15 dec 2020):
* bug fixes.
v1.9.6b (25 nov 2020):
* bug fixes.
v1.9.6 (24 nov 2020):
* iOS: SunVox Audio Unit (AUv3) can now be used as an effect (filter) inside other DAWs;
* sound engine optimization;
* new module - Pitch Detector for detecting the pitch of the incoming signal; the frequency and note will be displayed; notes will be sent to the module output; see example "pitch correction (automatic tuning)";
* new module - ADSR envelope generator; see examples adsr, adsr2, adsr3;
* new module - Ctl2Note for converting the controller value into a note (input - automation; output - notes); see example ctl2note;
* Analog Generator: new waveform "harmonics" allows you to draw the harmonic distribution; but remember, if you turn on all 32 harmonics, then the module's performance will slow down 32 times compared to a pure sine generator; reduced polyphony and LQmono mode will slightly reduce the CPU load;
* SpectraVoice: new harmonic types: overtones1+, overtones2+, overtones3+, overtones4+, metal;
* LFO: new controller "Frequency scale" (in percents) - use it to slow or accelerate the oscillations;
* LFO: new controller "Smooth transitions" - disable it to get hard transitions inside the waveform;
* Generator, Kicker, SpectraVoice: increased resolution (accuracy) of Attack and Release controllers; (only if the base version is 1.9.6 or higher in the Project Properties);
* Sound2Ctl: new option "Send only changed values";
* MultiSynth: new option "Round the note (X-axis on curve3) to the nearest integer" (remove microtones);
* MultiSynth: new option "Round the pitch (Y-axis on curve3) to the closest";
* MultiSynth: new option "Record notes to the scale (curve3)"; see example "dynamic scale";
* MultiSynth: new option "Output note = Output note - Input note + C5" (difference between output and input pitch);
* MultiSynth: new option "Output port number = note % number of connected outputs"; (% is the modulo (remainder) operation); see example "drumkit 3 (multisynth)";
* MultiSynth: new option "Output port number = polyphonic channel % number of connected outputs";
* MultiSynth: new curve 3 describing the dependence of the output pitch on the input note;
* MetaModule: new options "Receive notes from the keyboard" and "Don't receive notes from the keyboard";
* MetaModule -> User defined controllers: edit buttons (add,delete,move up/down) have been added;
* Pitch shifter: incoming notes change the value of controller 02.Pitch; the C5 note corresponds to zero;
* Pitch shifter: new controller "Bypass if pitch=0" - play the original signal when the module does not change the pitch;
* MetaModule, MultiSynth, Sound2Ctl, Sampler, Analog Generator: options can be accessed in the same way as controllers (see the exact numbers in the options list);
* new MIDI IN mode for modules - "never" (never receive MIDI data);
* improved popup menus: additional navigation keys (up,down,left,right,space,enter,escape); horizontal scroll if the menu does not fit on the screen; highlight of the current effect;
* new pattern effects (column EE): 05 and 06 - pitch bend up/down (one semitone = 100 (256dec));
* new keyboard shortcuts for the timeline: slice, mute, solo, unmute, set restart position, snap to grid (unassigned by default);
* new folder "curves" (with curves for MultiSynth, MultiCtl and WaveShaper);
* new modules in the instruments/ and effects/ folders;
* new examples (SunVox Compo 2020.02 winners): Trackerbound - Alpha Ursae Minoris, Trackerbound - Silentium, manganoid - Lazy Thunder, SawZer - Phantom;
* bug fixes.
v1.9.5d (20 feb 2020):
* bug fixes.
v1.9.5c (6 feb 2020):
* bug fixes.
v1.9.5b (24 jan 2020):
* iOS (AU): missing files added.
v1.9.5 (23 jan 2020):
* Android 6+: USB MIDI support;
* Android: arm64 and x86_64 support; Android 2.3 support has been dropped; now the minimum is 4.1;
* Android: now the SunVox remains in the background after you close the window; if you want to completely unload the app - use the EXIT menu item or the BACK button;
* iOS: Audio Unit Extension (AUv3 instrument) has been added - SunVox can now be used inside any AU host;
* iOS: Main menu -> Export/import: additional export/import functions provided by the system;
* extended set of supported MIDI sync commands (slave mode): Start/Stop/Continue, MIDI Clock, Song Position Pointer;
* full support of 65534 modules per project and 32 tracks per pattern;
* optimization of graphic and sound engines;
* Distortion: new type "overflow2" (symmetric overflow);
* Loop: incoming notes (Note ON commands) restart the loop;
* Delay now also delays the incoming events (note, pitch, phase, velocity);
* MultiSynth: new option "Generate missed Note OFF cmds";
* Pattern Editor: new function "Cyclic shift";
* new pattern effects (column EE):
  * 15 - change the relative note and finetune of the module; XX - relative note (00 - ignore; 01 = -127; 80 = 0; FF = 127); YY - finetune (00 - ignore; 01 = one semitone lower; 80 = 0; FF = one semitone higher);
  * 31 - jump to line XXYY (address) right after the end of the current line;
  * 32 - set jump address mode YY: 0 - absolute address, relative to the start of the timeline (default); 1 - ( pattern beginning + address ); 2 - ( pattern beginning - address ); 3 - ( next line + address ); 4 - ( next line - address );
* new set of destructive effects (irreversibly change the contents of the pattern):
  * 38 - delete an event on track XX with a probability of YY (00..FF(100%)); see simple_examples/pat effect 38 self destructive.sunvox
  * 39 - cyclic shift of track XX down by YY lines;
  * 3A - generate a new iteration of YY-line polyrhythm on track XX; see simple_examples/pat effect 3A polyrhythm.sunvox;
  * 3B - copy track XX to a pattern named YY;
* MutliCtl, Sound2Ctl, Pitch2Ctl, Velocity2Ctl: "OUT Controller" range has been increased to 255, so now it's also possible to address the MIDI controllers (CC0 = 128, CC1 = 129, ...) of the connected module(s);
* new module visualization settings: background options (outline/fill), level scale (linear/logarithmic(dB)/RMS), peak meter;
* Project properties: "Sync" settings allow you to specify the types of synchronization commands that the project accepts;
* Preferences -> Main: new option "Autosave" (disabled by default);
* Preferences -> MIDI: "Module preview channel" - MIDI channel that will be used to receive notes during module pre-listening (when selecting a file);
* Preferences -> MIDI: "Sync source" - MIDI device for receiving synchronization commands;
* Preferences -> Timeline: new option "Hexadecimal line numbers";
* Preferences -> Interface -> Shortcuts: delete buttons [x] have been added;
* improved text fields (long text scrolling has been added) + improved virtual text keyboard;
* simple copy/paste (ctrl+c/v) in all text fields;
* Wi-Fi export/import: additional file information fields: size and modification date/time;
* export to WAV: new mode "File per module (connected to selected)" - export modules connected (as sources) to the selected module;
* new keyboard shortcut: SHIFT + 7 - cyclic shift up (for the selected region in the pattern editor);
* new keyboard shortcut: SHIFT + 8 - cyclic shift down;
* new command-line option "-?" for help (show usage with all possible options);
* new command-line options: "-v <vol>" - set volume; "-t <line>" - jump to the specified position of the timeline; "-p" - play;
* new command-line options: "-of <format>" - set output format (wav16 (default) or wav32); "-o <filename>" - output to file;
* new instruments and effects from other users (see the instruments and effects folders);
* new examples (SunVox Compo 2019.03 winners): Trackerbound - its over now; make a wish; Logickin Lambda - Soar Beyond; manganoid - Dash of Wind;
* new examples: NightRadio - 5100, 5101, 5102, Sines of Night, Au; Manwe - Aquar.io Ambient; Philip Bergwerf - Venaya;
* updated version of SunVox library for developers: https://warmplace.ru/soft/sunvox/sunvox_lib-1.9.5.zip
* bug fixes.
v1.9.4c file update (16 aug 2018):
* sunvox_for_old_cpu (version for old CPU without SSSE3) has been added for Linux and Windows x86_64;
* file permissions have been updated.
v1.9.4c (3 aug 2018):
* fixed bug in Feedback module (stereo mode).
v1.9.4b (31 jul 2018):
* bug fixes.
v1.9.4 (29 jul 2018):
* iOS: user files are now available through the Files app;
* iOS: partial USB/Bluetooth keyboard support (no key release, no Home/End, no F1/F2/...);
* iOS: improved iPhone X display support;
* sound engine optimization;
* indicating the modules whose controllers are tied to the MIDI;
* additional slider for scrolling the controllers when there is not enough space on the screen;
* spectrogram has been added to the to the spectrum analyzer;
* detailed settings of the spectrum analyzer are now available through the main menu -> Preferences -> Modules; also you can find it in sunvox_config.ini;
* Amplifier: new controller "Gain" for high amplification (x100, x1000 and higher);
* Analog Generator: new option "True zero attack/release" - turn it on when you need a very fast (instantaneous) zero attack or/and release;
* Analog Generator: new waveforms: "noise with spline interpolation (sampler)", "white noise", "pink noise", "red noise", "blue noise", "violet noise", "grey noise";
* Compressor: new mode "peak zero latency" for compression/limiting without delay; modes "peak" and "RMS" operate with a delay of 1 ms;
* Distortion: new types: "foldback2", "foldback3", "overflow";
* GPIO: max number of pins is increased to 256;
* LFO: new waveform "random interpolated" (same as random (5), but with a smoother transition between the signal levels);
* DrumSynth: three additional panning controllers for the bass, hihat and snare;
* Kicker and DrumSynth: panning controller can now be set locally (for each note separately);
* Kicker: "Boost" (old name - "Vol.addition") controller works again after it was accidentally broken in SunVox 1.6 :) (base SunVox version in the project properties must be 1.9.4 or higher);
* MultiCtl: new controllers "Response" and "Sample rate" to smoothly change the output value; response=1000 - immediate change; response<1000 - smooth change; optimal sample rate = 150Hz, please avoid higher values without the urgent need;
* Timeline: new function "set restart position" - use it to change the position which the project should restart from after the project end;
* pattern effect 03 (slide to note): default speed value (XXYY) is 256 (100 in hex);
* new pattern effect 24: take a note from line XXYY on the same track; if the note to the left of the effect is specified, it will be used as the transposition value (relative to C5: c5 - one semitone higher, C4 - one octave lower, etc.); if the module number is missing, then the module number from line XXYY will be used;
* new pattern effect 25: take a random note from the range of lines XX..YY (inclusive) on the same track;
* new pattern effect 26: take a note from track XXYY on the same line;
* new pattern effect 27: take a random note from the range of tracks XX..YY (inclusive) on the same line;
* new pattern effect 28: take a note from line XXYY on track 0;
* new pattern effect 29: take a random note from the range of lines XX..YY (inclusive) on track 0; see example "pat effect 29 random note from trk0";
* module remapping: "pattern" button has been added;
* dialog window shortcuts: Y or ENTER = first button on the left; N = second button; ESC = cancel; 1...9 = buttons from left to right;
* if you enter the file name "exporttest" when exporting to WAV, the SunVox engine speed test will be performed (without saving to disk);
* new keyboard shortcut: CTRL + SHIFT + N - new project;
* new keyboard shortcut: SHIFT + F10 - play from the pattern cursor;
* new instruments: keyboard/NR SuperSaw (lo-fi), analog11, analog12, pads/analog_distorted2, wind/NR Sax;
* new instruments and effects from other users (see the instruments and effects folders);
* new simple examples: idm, pat effect 29 random note from trk0;
* sunvox_config.ini: denorm 0/1 - disable/enable denormal numbers; DON'T use this if you don't know what it is :)
* various small changes and improvements;
* bug fixes: unpredictable clicks in Vibrato and Vocal Filter, etc.
v1.9.3c (5 dec 2017):
* macOS: fixed bug in the MIDI IN code.
v1.9.3b (25 nov 2017):
* iOS 7 support has been dropped;
* bug fixes.
v1.9.3 (21 nov 2017):
* 64-bit Windows support (x86_64);
* Android (4.0 and higher): Preferences -> Interface: new option "Hide system bars" for true immersive fullscreen mode;
* iOS: Audiobus 3 support (with MIDI);
* macOS and Linux: experimental Wi-Fi export/import support (like on iOS);
* Linux: now SDL2 library is used instead of the old SDL1.2;
* desktop systems with the sample rate 48000 and higher: improved sound quality of the following modules: DrumSynth, Analog Generator, FM;
* sound engine optimization;
* MIDI IN options has beed added to the Module Properties: here you can change the MIDI IN channel and the mode (receive MIDI commands "when the module selected" or "always");
* the biggest Sampler update since 2008;
* Sampler: click removal algorithm (between two notes on the same channel, or during the sharp note cutoff);
* Sampler: added four new envelopes to control the effect (with polyphony support), which is one of the built-in SunVox modules; so you can choose almost any SunVox module (for example, Filter or MetaModule), and it will be stored inside the Sampler; 
* Sampler: new option "Ignore velocity for volume";
* Sampler (editor): the scroll wheel now increases/decreases the area exactly under the mouse cursor;
* Sampler (sample editor): new loop parameter - Sustain; when enabled, loop will be finished after the Note OFF;
* Sampler (sample editor): deeper zoom;
* Sampler (sample editor): supported shortcuts: Selection begin, Selection end, Paste and mix;
* Sampler (sample editor): Crossfade Loop effect has been added into the menu;
* Sampler (envelope editor): unlimited envelope length, unlimited number of envelope points;
* Sampler (envelope editor): supported shortcuts: Delete, Backspace, Insert, Tab, Left, Right, Up, Down;
* Sampler (envelope editor): point info display has been added; press it to show/hide the additional buttons for precise point control;
* Sampler (envelope editor): new envelope parameters: Gain, Velocity influence;
* Sampler (envelope editor): new envelopes: Pitch, Effect Controller;
* MetaModule: new option "Event output"; when enabled, the MetaModule can output events (Note ON/OFF, Set Pitch, etc.) from the internal Output module; see the examples metamodule_arpeggiator3/4;
* MetaModule: effect 07 (set sample offset by percentage) is now supported too; you can use it to jump to the specified location within the MetaModule-project;
* MetaModule: new mode "play without repeat" has been added to the "Play patterns" controller;
* Filter, Filter Pro, Flanger, LFO, Vibrato: current LFO phase is visible now (on the "Set phase" controller);
* Filter, Filter Pro, Flanger, LFO, Vibrato: the incoming notes (Note ON commands) reset the LFO phase to "Set phase" value;
* MultiSynth: new option "Trigger" (ignore Note OFF commands; the new note turns off the old note with the same pitch);
* MultiSynth: new controller "Curve2 influence" (mix between the linear (default) and the user-drawn curve2);
* Reverb: new controller "Random seed";
* LFO: new controller "Generator" (always generate a signal, even if the input is empty);
* LFO: triangle waveform;
* Pattern Editor: new function "Place evenly" (place events evenly in the selected area);
* new project parameter - "Time grid2" (the higher-level grid, number of time grid cells);
* "Randomize controllers" can now be canceled through the UNDO;
* lists of the recent files and folders have been added to the file browser; you can disable it in the Preferences -> Interface;
* "Resize" button has been added to the musical keyboard in the file browser (when the Preview is enabled);
* new keyboard shortcut in the file browser: BACKSPACE or LEFT - go to the parent directory;
* new keyboard shortcut: CTRL + P - place selected events evenly (pattern editor);
* new keyboard shortcut: remap (pattern editor) - keys are not assigned to this shortcut by default;
* almost all windows can be closed by pressing the ESC;
* additional small font for low-res displays; you can switch between the three built-in fonts in the Preferences -> Interface -> Fonts;
* Preferences -> Main: new button "Log" (show/save SunVox log);
* Preferences -> Interface: new option "Zoom buttons" (hide/show zoom in/out buttons);
* Preferences -> Interface -> Color theme: ability to manually adjust the four primary colors (c_0, c_1, c_2, c_3);
* new instruments and effects (see the folders instruments and effects);
* new examples: NightRadio - Reach for the Stars, Transient - Can It Be Beautiful;
* new simple examples: sampler effect envelopes, metamodule_arpeggiator3, metamodule_arpeggiator4;
* user manual update: http://www.warmplace.ru/wiki/doku.php?id=sunvox:manual_en;
* base configuration file update (description of all additional colors): http://www.warmplace.ru/soft/sunvox/sunvox_config.ini;
* bug fixes: note hang in Glide, broken virtual MIDI IN port in iOS, problems with Wi-Fi Export/Import, etc.
v1.9.2 (4 nov 2016):
* Windows (7 and higher): multitouch support;
* Linux: arm64 architecture support (tested on PINE64 64-bit Single Board Computer);
* Linux: interface rotation support;
* new module Pitch2Ctl: converts the incoming notes to the controller values (in some another connected module);
* new module Velocity2Ctl: converts the velocity parameter of the incoming notes to the controller values (in some another connected module);
* new project parameter - "Time grid" (number of lines per grid cell);
* add option "nowin" to the sunvox_config.ini if you want to launch SunVox without the window (pure console mode without UI);
* Main SunVox Menu: new function "Merge project" (load project over the current);
* Timeline: target pointer (like in the Module View) has been added; use it to choose where to place the new pattern(s);
* Timeline: now the file is used for the pattern copy-buffer; so you can paste even after the SunVox restart;
* Analog Generator: new options "Retain phase" (don't reset the phase) and "Random phase";
* Analog Generator: new options "Filter frequency = note frequency" and "Velocity-dependent filter resonance"; see the analog_gen4 and analog_gen5 examples;
* Analog Generator: new waveform "Drawn with spline interpolation";
* MultiSynth: new button "Set" (set exact values of the curve);
* Vibrato: new controller "Exponential amplitude";
* Kicker: sine waveform has been added;
* LFO: random (noise) waveform has been added;
* Loop: new controller "Mode" (normal/ping-pong loop playback); see the loop2 example;
* MetaModule: optimized interface + default user controller names;
* Sampler: new option "Stop recording on project stop";
* MultiCtl: new controller "OUT offset";
* frequency/delay limits (only for ms and Hz units) has been increased in the following modules: Echo, Delay, Vibrato, LFO;
* improved MIDI Import and Export: channel/program/bank/controller support; new timing algorithm;
* ability to switch between the text fields using the TAB/SHIFT+TAB keys;
* new oscilloscope mode (module visualizer) - XY (X = left channel; Y = right channel);
* now all notes are visible on the musical keyboard: expand it up to see the full range;
* Modules (routing): new function "Find" (find a module by name);
* Pattern Editor: improved hints;
* Pattern Editor: click on some event (note or some other command) and the corresponding module will be highlighted;
* Pattern Properties: new buttons "Shrink /2" and "Expand *2" has been added;
* Preferences -> Main: new option "Make project backup before the first overwrite";
* Preferences -> Timeline: new option "Show line numbers from ...";
* Preferences -> Timeline: new option "Grid cell size";
* Preferences -> Interface: new option "Double click time" (in ms);
* Preferences -> Interface -> Scale: new parameter "Font scale";
* new keyboard shortcut: CTRL + 1 - toggle mute (module);
* new keyboard shortcut: CTRL + 2 - toggle solo (module);
* new keyboard shortcut: CTRL + 3 - toggle bypass (module);
* new keyboard shortcut: CTRL + 4 - unmute all modules;
* new keyboard shortcut: CTRL + F - find a module;
* sunvox_no_simd for Linux x86 has been temporarily removed; use sunvox_lofi instead;
* new instruments and effects;
* new simple project examples: analog_gen4, analog_gen5, dubstep, loop2, pitch2ctl ***;
* new song examples: Quantum Countdown, PalmSounds10, Kiberaver - Hard Motor;
* updated version of SunVox library for developers: http://warmplace.ru/soft/sunvox/sunvox_dll.zip;
* bug fixes.
v1.9.1 (9 jan 2016):
* new module - Glide; it is similar to the MultiSynth, but it also adds the commands of smooth transition between the notes; see the glide.sunvox example;
* advanced Interpolator has been added to the Pattern Editor: with this tool you can make a smooth transition of the values of any pattern columns, with various parameters (like the curve type, noise, etc.);
* new function in the Modules (routing) window - Replace; use it if you want to replace the selected module by some other module without loss of connections;
* MIDI buttons (with notes) linked to some SunVox actions (shortcuts) are now ignored by the synths;
* added restoring of the JACK MIDI input connections;
* Sampler (sample editor): now the Copy and Paste functions work through the file;
* Sampler (sample editor): new effects (Invert and Center) has been added;
* LFO: new controller "Duty cycle" (only for the square waveform);
* CUT operation has been added to the Modules (routing) and the Timeline;
* new keyboard shortcut: SHIFT + > - select the next module;
* new keyboard shortcut: SHIFT + < - select the previous module;
* new keyboard shortcut: CTRL + > - select the next synth;
* new keyboard shortcut: CTRL + < - select the previous synth;
* new keyboard shortcut: CTRL + RIGHT - next module horizontally;
* new keyboard shortcut: CTRL + LEFT - previous module horizontally;
* new keyboard shortcut: CTRL + DOWN - next module vertically;
* new keyboard shortcut: CTRL + UP - previous module vertically;
* new instrument from Cube48: DrumSynth48;
* new simple song examples: glide;
* new song examples: snowfall, SunVox Compo 2015.10 Winners (KnyazIvan - fatal precession, OceanicDegree - Dreaming, echo2 - unreal love 3);
* bug fixes.
v1.9b (26 jul 2015):
* special SunVox version (sunvox_no_simd) has been added for Linux x86 machines with old CPUs without SIMD instructions;
* Project Properties: the new field "Based on SunVox (version)" has been added; change it if you think that some modules use the old buggy algorithm (Compressor for example);
* bug fixes.
v1.9 (19 jul 2015):
* additional UI language - Russian; you can change it in Preferences -> Interface;
* PalmOS and Meego are no longer supported, but you can always download SunVox 1.8.1 for these systems from warmplace.ru;
* Android: SunVox file type association (like in iOS version): now any SunVox-compatible documents (sunvox, sunsynth, midi, xm, mod, xi, etc.) can be opened from other apps (Mail, Browser, etc.);
* Android and iOS: engine is now optimized for OpenGL ES 2.0;
* new module - Feedback (see the examples);
* new module - Filter Pro (High quality IIR filter);
* number of MIDI slots (in Preferences) has been increased to 4; so you can use four MIDI controllers simultaneously;
* now any external MIDI knob can be connected to any number of SunVox controllers of any modules;
* now any SunVox shortcut can be connected to external MIDI button (Note, CC or Program Change);
* click twice (or right click) on the controller to open the new Controller Properties window;
* you can do the following operations in the new Controller Properties window: change, reset, randomize, write to pattern, assign MIDI IN;
* MultiSynth: new controller "Phase" - the starting position of the sample or the starting phase of some Generator;
* MultiSynth: added support of the "Set Sample Offset" pattern effects 07 and 09;
* MultiCtl: new controller "Quantization" - the number of quantization levels;
* Sampler: new controller "Rec threshold" - the level at which the Sampler should start recording;
* Sampler: ability to import the loop points from WAV;
* Generator: "P.Modulation" controller has been renamed to "Freq.Modulation input";
* Filter: new controller "LFO waveform";
* Amplifier: new controller "Fine volume";
* Modulator: "Phase Modulation" mode has been added;
* new functions in the Pattern Editor menu: selection begin, selection end;
* slightly redesigned Pattern Editor;
* new pattern effect: 13 - Set Bypass/Solo/Mute (BSM = XYY) flags; example of mute: 13 0001; example of solo: 13 0010;
* new pattern effect: 14 - Reset Bypass/Solo/Mute (BSM = XYY) flags; example of bypass reset: 14 0100;
* Song has been renamed to Project;
* new keyboard shortcut: SHIFT + F12 - go to beginning;
* new keyboard shortcut: SHIFT + ) - octave up;
* new keyboard shortcut: SHIFT + ( - octave down;
* new keyboard shortcut: CTRL + ( - selection begin (pattern editor);
* new keyboard shortcut: CTRL + ) - selection end (pattern editor);
* new instruments from NightRadio, Pavel Ti, SolarLune and other authors;
* new simple song examples: feedback, feedback2, modulator (phase modulation);
* new song examples: 4004, music_in_our_souls, awakening_city, Transient - Tablerock, SunVox Compo 2015.02 Winners (Sirmooge - Phalanx, Pavel Ti - Boomer, KnyazIvan - Cold Summer);
* bug fixes.
v1.8.1 (29 dec 2014):
* bigger Compressor visualizer;
* GPIO module is now available on all devices, but it is fully functional in Linux only;
* bug fixes.
v1.8 (17 nov 2014):
* audio engine has been switched to 32bit (Floating Point) mode on Android and iOS devices (except the slow devices without FPU);
* other than 44100 sampling rate support for iOS and Android (only if the audio hardware supports it);
* iOS: Audiobus 2 and IAA (partially) support;
* new Modules (routing) window functions: Zoom (with multi-touch support), Snap to Grid;
* MetaModule: EDIT button has been added; now you can edit MetaModules without annoying Loading/Saving;
* MetaModule: additional options: Arpeggiator (change the pitch of internal MetaModule patterns), Apply velocity to song;
* Sampler: the following options have been added: Record on play (use it if you want to record in sync with the PLAY button), Record in mono, Record with reduced sample rate, Record in 16bit;
* SpectraVoice improvements: auto render, additional sample size, new band types (random, triangle1, triangle2, overtones1, overtones2, overtones3, overtones4);
* Sound2Ctl: "Record Values" option has been added; now all values from this module can be recorded alongside with the other SunVox events (notes, Theremin, etc.);
* offset commands (effect codes 09 and 07) support has been added to the following modules: Generator, Analog Generator;
* MultiSynth: new controller "Random phase" has been added; for example, with this option you can play the Sampler's notes from the random position;
* MultiSynth: new controller "Random velocity" has been added;
* Analog Generator: new option "Filter freq. scaling per key (reverse)";
* Analog Generator: new controller "Noise" - amount of the white noise;
* new pattern command: Previous Track; use it to apply the effects to the previous track; but the following secondary effects are not allowed: 2x, 40..5F, 1D;
* new button in the Pattern Editor: Spec.Cmd - press it to insert a special command (Set Pitch or Previous Track);
* press SHIFT and change the value of some controller - the new value will be written to the pattern;
* press SHIFT and play some note on Touch Theremin - the new microtone (Set Pitch XXYY command) will be written to the pattern;
* new module - GPIO (only for Linux with GPIO Sysfs Interface enabled); with this module you can send or receive the signals to/from GPIO pins; check the test project - raspberry_pi_gpio;
* additional MIDI slot has been added to the Preferences; now you can use two MIDI keyboards simultaneously;
* Timeline section has been added to the Preferences;
* new option: Preferences -> Timeline -> Show timeline (always show Timeline on the screen);
* new keyboard shortcut: SHIFT + F9 - record start/stop;
* new keyboard shortcut (pattern editor): SHIFT + [ - transpose octave down;
* new keyboard shortcut (pattern editor): SHIFT + ] - transpose octave up;
* new keyboard shortcut (pattern editor): CTRL + m - paste and mix;
* new keyboard shortcut (pattern editor): SHIFT + k - insert the "Previous Track" special command;
* new simple song examples: spectravoice2, metamodule_arpeggiator, metamodule_arpeggiator2, std_effect_multitrack, std_effect_multitrack2, std_effect_multitrack3, raspberry_pi_gpio;
* new song examples: alchemy_masters, full_moon_night, Twistboy - Translucent, Spline - Endless August, Knyazivan - Left Double Quotation Mark;
* bug fixes.
v1.7.5 (26 jun 2014):
* iOS: 64bit CPU support;
* iOS: SunVox file type association: now any SunVox-compatible documents (sunvox, midi, xm, mod) can be opened from other apps (Mail, Browser, etc.);
* new module - Pitch Shifter;
* shortcut configuration (key redefinition) window has been added to the Main Menu -> Preferences -> Interface;
* customizable curve of the values has been added to MultiCtl module;
* MIDI Octave Offset option has been added to the MIDI Preferences;
* avconv (libav) support on systems without ffmpeg;
* PR (Set note period) command has been renamed to SP (Set pitch);
* main menu has been divided into two separate menus: the Main Menu (left side) and the Pattern Menu (right side);
* UI design slightly changed;
* Play (F9) shortcut has been changed to Play/Stop;
* new keyboard shortcut: F10 - play from beginning;
* new simple song examples: crossfader;
* new song examples: Twistboy - Translucent, unspoken_words;
* bug fixes.
v1.7.4b (4 feb 2014):
* MetaModule: number of user defined controllers has been increased to 27;
* Delay: new controller "Delay units" has been added; possible values: sec/16384, ms, Hz, ticks, lines, lines/2, lines/3;
* Delay: max delay length has been increased to 1/4 second (PalmOS) and 4 seconds (other systems);
* Main Menu -> Preferences -> Main: new option "Automatic session restore" has been added; enable it to hide the "Restore Previous Session" dialog;
* Timeline: new font + text wrapping;
* bug fixes.
v1.7.4 (23 jan 2014):
* SunVox has been ported to Raspberry Pi;
* engine optimization;
* extended Visualization Parameters in the Module Properties: type of the Level Meter, type of the Oscilloscope, background, shadow, etc.;
* available Level Meter modes: OFF, Mono, Stereo, Color, Glow effect;
* available Oscilloscope modes: OFF, Points, Lines, Bars, Bars2 (symmetrical), Stereo phase scope (Goniometer), Stereo phase scope x2;
* default Visualization Parameters can be set in the SunVox Preferences (Main menu -> Preferences -> Modules -> Default visualizer);
* new module - Sound2Ctl; this module can convert the audio signal to the numeric value of any selected controller;
* new module - MultiCtl; with this module you can control multiple controllers at once;
* WaveShaper: new controller "DC filter" (DC Blocking Filter) has been added; enabled by default;
* Amplifier: new controller "Absolute" has been added; enable it to apply "absolute value" filter to the signal;
* MultiSynth: new buttons have been added: Options, Reset, Smooth, Load, Save;
* MultiSynth: now you can switch between different types of Velocity Graphs in the Options menu; it is useful for complex velocity mapping;
* DrumSynth is now supports Velocity Change commands;
* "Change font size" option has been changed to "Scale"; and now you can change the pattern editor scale very smoothly on any device;
* now you can set the name of the pattern, instead of the 16x16 icon;
* the Scale parameter can be changed for each module separately (in the Module Preferences, or using CTRL + MOUSE WHEEL);
* now the screen orientation can be changed manually (only for Android, WinCE and PalmOS) in the Preferences -> Interface -> Angle;
* additional File Browser functions: Remove, Rename, Cut, Copy, Paste, Create Directory;
* now you can see the file size in the File Browser (except PalmOS);
* new simple examples: sound2ctl*, drumsynth*;
* new song examples: moon_secrets, CsardasContinuum (by Frantisek Fuka (Fuxoft)), berlin_fm_-_nt, visualizer_demo, silence_artifacts;
* bug fixes.
v1.7.3c (14 may 2013):
* additional LFO module waveforms: sin2 (correct sine), saw, saw2;
* added ability to record into the selected Sampler slot;
* fixed bug with JACK MIDI input;
* fixed bug with the Sampler base note calculation;
* base note for the Vorbis Player is C5;
* new song (examples): april_song.
v1.7.3b (27 apr 2013):
* fixed several bugs (iOS 4-inch screen, Audiobus, UI).
v1.7.3 (12 apr 2013):
* iOS: added Virtual MIDI Port;
* iOS: support of Audiobus;
* iOS: support of 4-Inch display;
* support of JACK Audio Connection Kit (for iOS and Linux);
* improved Compressor algorithm;
* default base note for WAV/AIFF samples is C5;
* SunVox file is now includes additional information: timeline cursor position, current module, current pattern;
* sound engine optimization;
* new ASIO driver options;
* Input Module (Mic/Line-in capture) is now also available for Linux (ALSA), Windows (MME,DirectSound,ASIO), Windows Mobile (with full duplex drivers only) and OSX;
* extended list of the audio buffer sizes in the Preferences->Audio: 128, 256, 512, 768, 1024, 1280, 1536, 1792, 2048, 2560, 3072, 4096;
* new options in the Preferences->Audio: Driver, Output Device, Input Device, Frequency;
* new option in the Preferences->Interface: Window Parameters (width, height, fullscreen mode); fullscreen mode is only compatible with Windows and Linux;
* added options for the MultiSynth: Use static note C5 (treat all received notes as C5); Ignore notes with zero velocity;
* new Pattern Editor function - Slice by cursor;
* added MIDI import; now you can load any MIDI files directly through the Load Song dialog;
* added support of the following MIDI commands: Start, Continue, Stop;
* number of MetaModule User Defined Controllers can be changed from 0 to 13;
* added MIDI Omni Mode (all MIDI channels will be accepted);
* new option in the Preferences->Interface: Show virtual keyboard; use it to show or hide virtual qwerty keyboard;
* scrolling when highlighting in the Sample Editor;
* per-pattern Mute/Solo (Timeline menu -> Toggle mute / Toggle solo);
* Vorbis Player is now supports the sample offset commands (09 and 07);
* added ability to create a new pattern by double clicking on an empty area of the Timeline;
* new Timeline function - Slice Pattern(s) (knife position = current playing position);
* new pattern effect 23 - set controller value to the random number with range from XX (00..FF) to YY (00..FF);
* new pattern effect 1F - set BPM;
* new songs: Manwe - Early Fall remake (original by Tangrine), kostya_m - Midnight, take_my_hand, follow_the_sun;
* new simple examples: metamodule_test, metamodule_with_automation, random_ctl_values_with_range, trance, compressor2;
* new instrument (pads): moving_pad, vocal_synth, filter_slide_up, analog, analog2, analog3, analog_distorted, space, violin, violin2, violin3, violin4;
* new instrument (keyboard): analog10, fm2, bell2;
* bug fixes.
v1.7.2b (22 sep 2012):
* sampler freeze bug fixed;
* changes in WinCE file functions;
* Android: ability to install on external SD card;
* Android: added confirmation dialog for BACK button;
* bug fixes.
v1.7.2 (3 sep 2012):
* for Android users: if your display flickers sometimes, put option_glnoretain.txt file (with any content) to the following directory: device SD card/Android/data/nightradio.sunvox/files/;
* now XM and MOD files (formats of old trackers) can be loaded without the converter, through the Main Menu -> Load Song; you can find hundreds of these files on this site: modarchive.org;
* extended list of effects for XM/MOD to SunVox conversion;
* new pattern effect 30 - use it to stop playing the song;
* new controller in the Reverb module - "All-pass filter"; use it to enable/disable output all-pass filter;
* new controller in the Reverb module - "Room size";
* added autorepeat mode for the following buttons: HLD (clear current note), OFF (insert Note OFF), INS (insert), BCK (backspace);
* added eight layers for the modules; for example you can place some complicated drum chain on the first layer, and all other synths - on the second layer; layers can be visible together or separately;
* new function "Scale" in the Module menu: use it if you want a smaller or bigger module size for the current project;
* changing the size of the modules by mouse wheel (scroll wheel);
* new module - WaveShaper;
* new module - MetaModule; with this module you can include some external .sunvox song to your project and use this song as synth or effect; Not available for PalmOS;
* new options in the Preferences->Recording: Pattern fit to grid, Note quantization, Controller quantization;
* new option in the Preferences->MIDI: Ignore velocity;
* new option in the Preferences->Audio Ouput: Audio buffer size;
* empty parameter of the vibrato effect 04 is now treated as "use previous parameter value"; works only for songs created in SunVox 1.7.2 and higher;
* new option "Smooth frequency change" in the Analog Generator; enabled by default; disable it if you want to use arpeggio effect 08;
* velocity map in the MultiSynth module;
* improved CPU Usage Monitor with scrolling and module selection;
* maximum number of pattern tracks has been increased from 8 to 16;
* maximum Echo delay length increased to 4 seconds (except for PalmOS, where still the maximum is 1 second);
* new controller in the Echo module - "Delay units" with different available modes (ms, Hz, ticks, lines);
* new controller in the Filter module - "LFO frequency units" with different available modes (ms, Hz, ticks, lines);
* new controller in the Flanger module - "Vibrato speed units" with different available modes (ms, Hz, ticks, lines);
* new controller in the LFO module - "Frequency units" with different available modes (ms, Hz, ticks, lines);
* new controller in the Vibrato module - "Frequency units" with different available modes (ms, Hz, ticks, lines);
* new controller in the Vibrato module - "Set phase";
* new simple examples: MIDI_out, waveshaper, velocity_map, reverb2, reverb3;
* new instrument in instruments/bass directory: analog_bass;
* new instrument in instruments/pads directory: synth_violin;
* new instruments in instruments/keyboard directory: piano14, piano15, space, space2;
* new instruments in instruments/various directory: electric_guitar, noise_slide_up, electro_drum_loop;
* keyboard instruments piano04.wav, piano05.wav has been replaced by piano04.sunsynth, piano05.sunsynth;
* sound engine optimization;
* bug fixes.
v1.7 (9 apr 2012):
* ported to Android;
* ported to Meego;
* real-time recording of any types of sound events (notes, Touch Theremin, controllers changing); WARNING: recording is not available for PalmOS version;
* if you want to enable/disable the metronome for recording - go to the Main Menu -> Preferences -> Recording -> Metronome = ON/OFF;
* new module: Analog Generator with the following features: 32 double alias-free oscillators with internal 12/24dB filters; exponential envelopes; smooth parameters changing;
* Bypass 'B' button has been added to the window with module's controllers;
* View 'V' button has been added to the window with module's controllers: with this button you can change the view mode (one, two or four columns);
* polyphony has been increased from 16 to 32 for the Sampler and the SpectraVoice;
* number of sample slots has been increased from 16 to 128 for the Sampler;
* "Roll-off" (dB per octave) controller has been added to the Filter module; available values: 12dB; 24dB; 36dB; 48dB;
* now you can load samples through the "Load Module" file dialog; Sampler will be created automatically;
* "Preview" button has been added to the "Load Module" file dialog;
* mouse wheel is now enabled for any type of controllers and scrollbars;
* mono mode has been added to the LFO module;
* new features in the Main menu -> Edit: Shrink pattern and Expand pattern;
* new pattern effects 40...5F - delay an event for selected fraction of the line (from 40 (0%) to 5F (100%));
* new pattern effect 04 - vibrato with parameters XXYY, where the XX - frequency, YY - amplitude;
* new pattern effect 22 - set controller value to the random number from 0 to XXYY (parameter);
* new controller in the Filter module: "Exponential freq" for exponential frequency;
* new function "Stereo to mono" added to the Sampler (sample editor);
* new sunvox_config file option: pencontrol - force UI (User Interface) optimization for Pen/Mouse control; 
* new sunvox_config file option: ppi - pixels per inch; example: ppi 160;
* new sunvox_config file option: scale - UI scale factor (normal=256); example: scale 128 //reduce the size of UI items in half;
* new sunvox_config file option: synths_min_num - minimum number of modules on x-axis;
* new parameters (Control Type and Scale) in the Preferences for the UI scale configuration; use it if you want larger or smaller interface elements;
* Windows: now DirectSound is default sound system; but if you need ASIO output, just select it in the sunvox_config.ini file (audiodriver asio);
* iOS: "Create Directory" feature added to the Wi-Fi file browser; 
* new examples: electrohouse, afternoon, pong, space_trip, 8bit_tales, sfields1, 1bit;
* new instruments (pads): moving_pad, vocal_synth, filter_slide_up;
* new instruments (keyboard): analog10, fm2;
* sound engine optimization;
* bug fixes.
v1.6.4 (3 aug 2011):
* new module: Side Chain Compressor;
* new module: DrumSynth with 120 unique synthetic drum sounds;
* new module: Amplifier;
* added multitrack WAV export;
* double click on the empty area of the Modules (routing) window -> Create a new module;
* double click on some pattern of Timeline -> Open a window with pattern properties;
* maximum BPM increased to 800;
* interactive waveform drawing added to Generator (only for type 4 (dirty));
* added new simple examples: compressor, drumsynth1-4;
* added new examples: chain reaction;
* iOS: added stereo mode to Input module;
* iOS: added Online Help (in Main Menu);
* bug fixes.
v1.6.3 (19 may 2011):
* fixed several serious bugs in sound engine; 
* new pattern effect 07 - set sample offset by a percentage (from 0000 to 8000).
v1.6.2 (13 may 2011):
* quantization noise is reduced by 4 times (on smartphones and pocket computers);
* added Lo-Fi (fixed point) SunVox versions for slow computers (only for Win32 and Linux x86);
* improved sound quality of the following modules: Generator, SpectraVoice;
* new Generator waveforms: half-sine (6); abs-sine (7); pulse-sine with duty cycle (8);
* added copy and paste of modules;
* added new control "Velocity" to MultiSynth module;
* added ASIO support (for Windows only);
* now Sampler can record signals from another modules; just connect some output module (Generator, for example) to the Sampler and press the "Rec", "Rec mono" or "Rec LoFi" button under the Sampler controllers; "Rec" - record stereo; "Rec mono" - record mono; "Rec LoFi" - record mono with reduced sampling frequency;
* added base MIDI IN/OUT in versions for Linux (ALSA), OSX and iOS (CoreMidi), Windows (MM); 
* supported MIDI IN commands: NoteON/OFF;
* supported MIDI OUT commands: NoteON/OFF; Control Change; Program Change; Bank Select;
* use controllers with number 80+X to send MIDI Control Change; where the X is MIDI Controller Number; for example: 8100 8000 - set Modulation (MSB and LSB) to the max value;
* added Input module for audio receiving from microphone or line-in; at the moment only iOS supported; the Input for other systems will be available in the next releases;
* iOS: added D-pad for more precise cursor positioning in the pattern editor;
* iOS: added Audio Copy/Paste (Intua Audio Sharing); Sonoma compatible; Where to find: Main menu -> Export/import -> Copy/Paste;
* iOS: added multitouch support to Touch Theremin;
* iOS: added multitouch support to piano keyboard;
* added Preferences (in the Main menu);
* templates support (in the Preferences);
* fixed bug with overload of EQ module;
* added new songs and instruments (samples);
* bug fixes.
v1.6.1 (5 jan 2011):
* Win Mobile: fixed bug with spectrum analyzer freezing.
v1.6 (10 dec 2010):
* GUI improvement and optimization;
* Maemo port (tested on Nokia N900);
* iOS: added screen orientation locking;
* iOS 4 multitasking support;
* iOS: added file sharing (SunVox <-> iTunes);
* added spectrum analyzer;
* new module: OGG Vorbis Player; note: this module is not available for the PalmOS devices;
* new module: Amplitude Modulator (multiplier);
* added new controller in "Distortion" module: "Noise";
* added LFO to the "Filter";
* improved sound quality of the "FM" module;
* improved sound quality of the "Kicker" module;
* added high-quality cubic interpolation to the "Sampler" module; note: this mode doesn't work on handheld devices with integer engine;
* added a set of built-in color themes;
* you can specify your own colors using the c_0, c_1, c_2 and c_3 options in the sunvox_config file; example: c_0 #00FF80;
* added UNDO/REDO functions (trough the main menu or CTRL + Z / CTRL + Y / SHIFT + CTRL + Z);
* added "edit step" to the pattern editor;
* new keyboard shortcut (pattern editor): CTRL + MINUS - decrease edit step;
* new keyboard shortcut (pattern editor): CTRL + PLUS - increase edit step;
* correct solo/mute handling in the "MultiSynth" module;
* added "Module remapping" function (main menu -> edit -> remap);
* fixed bug with relative note in the "MultiSynth";
* sunvox_config: added "zoom" option; you can use it for larger pixels on Linux devices with SDL, or on WinCE devices with RAW video driver; example of usage: zoom 2;
* added new songs and simple examples;
* bug fixes.
v1.5.5d (7 may 2010):
* fixed bug with cursor on the timeline;
* fixed bug with WAV/AIFF/XI preview;
* fixed bug with scrollbar.
v1.5.5 (4 may 2010):
* added new controller in "Generator" module: "Duty cycle" (only for rectangular waveform);
* WAV/AIFF/XI preview in the "load" dialogs of the "Sampler";
* animated visualization of the state of the "Sampler";
* new keyboard shortcut (pattern editor): CTRL + D - duplicate;
* new keyboard shortcut (pattern editor): CTRL + I - interpolate value;
* new keyboard shortcut (pattern editor): CTRL + U - interpolate velocity;
* new keyboard shortcut (modules): CTRL + N - create a new synth;
* new keyboard shortcut (modules): CTRL + R - randomize synth controllers;
* new keyboard shortcut (timeline): CTRL + N - create a new pattern;
* new keyboard shortcut (timeline): CTRL + D - clone pattern(s);
* new keyboard shortcut (timeline): CTRL + C - copy pattern(s) to buffer;
* new keyboard shortcut (timeline): CTRL + V - paste pattern(s) from buffer;
* new keyboard shortcut (timeline): CTRL + A - select all patterns;
* 24bit WAV support;
* experimental MP3/OGG/FLAC/... support via ffmpeg under the Linux.
* fixed bug in the "FM" synth.
v1.5.1 (3 apr 2010):
* sound engine optimization;
* new module: DC Blocker (DC Blocking Filter);
* new module: EQ (3Band Equalizer);
* new module: MultiSynth (translates sound events to any number of synths);
* new synth activity scopes;
* added signal clipping indicator;
* color selection for synths;
* simple MIDI export;
* AIFF (uncompressed) support;
* added new example track: multisynth;
* sunvox_config: removed "flip" option; added "rotate" option; example of usage: rotate 90 //turn the screen by 90 degrees;
* sunvox_config: added "maxfps" option; use this option for setting maximal number of frames per second; less value - less CPU usage;
* sunvox_config: added options for control the size of the synths: synth_max_xsize, synth_min_xsize, synth_xsize_divider, synth_ysize_multiplier;
* sunvox_config: new options "no_scopes" and "no_levels" for slow devices;
* now SunVox can load its configuration either from sunvox_config.ini or sunvox_config.txt.
v1.4.5 (11 oct 2009):
* new module: Vibrato;
* added sinusoidal waveform to the "Generator";
* added new effects 11 and 12 - fineslide up/down;
* added new effect 20 - set the probability (0...8000) of a note being triggered; this effect is for unpredictable rhythms;
* added new effect 21 - same as 20 but with random velocity;
* added new example track: endless_song (based on new effect 20);
* new functions in the "Sampler": resample; volume fade; waveform drawing (paint mode);
* improved "transpose" function in the pattern editor;
* pattern follow mode (only for single pattern playing);
* sound engine optimization.
v1.4.1 (2 aug 2009):
* fixed several bugs in Mac OS X version;
* removed text console from Windows version.
v1.4 (24 jul 2009):
* iPhone port;
* OSX port;
* multitouch support;
* design improvements and optimization;
* updated icon editor (now in separate window);
* updated sampler (added base note and frequency for each sample);
* sunvox_config: added "touchcontrol" option; use this option if your device has touchscreen without pen (stylus), or if you just want a large buttons;
* sunvox_config: now "audiodevice" option works in Windows (and Windows Mobile) too; example of usage: audiodevice 1 //set second audio device of your computer;
* added new effect 19 - re-trigger note after XXYY ticks during the line;
* added new effect 1C - cut note after XXYY ticks in the current line;
* added new effect 1D - delays the start of note until tick XXYY in the current line;
* added respective simple examples: std_effect_retrig.sunvox; std_effect_cut.sunvox; std_effect_delay.sunvox;
* added "hide effects" function in the pattern editor's menu;
* added "Touch Theremin" experimental tool for realtime playing;
* bug fixes.
v1.3b (30 mar 2009):
* fixed bug with incorrect sunvox_config file loading;
* added new "videodriver" option to the sunvox_config file; possible values for WinCE devices: gapi (default), raw (raw hires framebuffer), gdi (compatibility mode);
* graphics in PalmOS version changed from grayscale 8bit to colour 16bit;
* added possibility to change the color (foreground and background) of pattern's icon;
* code optimization;
* bug fixes.
v1.3 (20 mar 2009):
* fixed bug with ping-pong loop in the "Sampler";
* fixed bug with big values in scrollbars;
* fixed bug with wrong song length calculation;
* fixed bug with panning in the FM synthesizer;
* new keyboard shortcuts: F9 - play; F11 - play pattern; F12 - stop;
* added new parameter "P.Modulation" to the "Generator" for phase modulation with input signal;
* added possibility to load samples from RAW and JPEG files;
* added support of 32-bit (floating point) samples;
* added new effect 8 - arpeggio;
* added new effect 9 - set sample offset;
* added new simple examples: phase_modulation, phase_modulation2, arpeggio;
* added right-click pop-up menu in the pattern/synth editors;
* added button for changing the piano keyboard size;
* added UTF-8 support to engine;
* pattern icons became resizable in the timeline window;
* now the timeline and the synth network may be shown at the same time if initial window size is greater than 640x480;
* inproved ALSA support (thanks to Will Light);
* updated manual;
* code optimization;
* bug fixes.
v1.2 (13 jan 2009):
* added external mod2sunvox utility for MOD/XM -> SunVox files conversion;
* added synth activity indicators;
* added CPU usage monitor (not working on PalmOS);
* added "mute" and "solo" buttons to the window with synth controllers;
* added "zoom in" and "zoom out" buttons to the timeline window;
* added "set vibrato phase" controller in the "Flanger" synth;
* improved reverb performance;
* increased frequency ranges of synths;
* updated manual;
* redesigned some GUI elements;
* bug fixes.
v1.1b (16 nov 2008):
* added new pattern length - 256;
* fixed bug with the pattern removing;
* fixed bug with the screen resizing on some PalmOS devices;
* fixed bug with the ALSA support (Linux).
v1.1 (26 oct 2008):
* new module: Delay;
* new module: LFO;
* new module: FM synth;
* new module: Reverb;
* new module: Vocal Filter;
* added "anticlick" controller in the "Kicker" synth;
* added "vibrato type" controller in the "Flanger" synth;
* added "mix" controller in the "filter" synth (mix original signal with filtered);
* added new mode "cubic interpolation" for high quality sound in the "SpectraVoice"; (not working on PDA);
* new feature: changing font size in the pattern editor;
* new feature: main menu -> edit -> interpolate velocity;
* new examples: city_dreams, forests, pong, window;
* new simple examples: delay, delay2, reverb, lfo, fm, voice;
* fixed major bugs on PalmOS devices with non-square screen;
* added sample-editor to the sampler module;
* ALSA support in Linux;
* redesigned some GUI elements;
* code optimization.
v1.0b (8 apr 2008):
* fixed bug with crash on some new PalmOS devices.
v1.0 (5 apr 2008):
* the first release.
